#ifndef __OBJECT_H
#define __OBJECT_H

#include "vector.h"

class CObject
{
public:
     CVector position;        // position of object
     CVector velocity;        // velocity of object
     CVector acceleration;    // acceleration of object
     scalar_t size;           // size of bounding sphere

public:
     CObject() {};            // constructor
     ~CObject() {};           // destructor

     virtual void Load() = 0;      // load into memory
     virtual void Unload() = 0;    // unload from memory
     virtual void Draw() = 0;      // draw object

     // animate object (physics calculations)
     virtual void Animate(scalar_t deltaTime) = 0;
};


#endif