#ifndef __TABLE_H
#define __TABLE_H

#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include <gl/glaux.h>
#include <math.h>
#include "vector.h"
#include "object.h"
#include "texture.h"
#include "plane.h"

/*

  CTable (derived from CObject)

  Description: The air hockey table. Holds the table corner coordinates,
               table wall planes, and table texture.
*/

class CTable : public CObject
{
private:
     CTexture iceTex;              // table texture

public:
     float tableCorners[4][3];     // table corner coordinates
     CPlane tableWalls[4];         // table wall planes

     CTable() 
     {
          position = CVector(0.0, 0.0, 0.0);
     }

     ~CTable()
     {}

     void Load();
     void Unload();

     void Draw();
     void Animate(scalar_t deltaTime);
     void SetupTexture();
};

#endif 